/*********************************************************************\
            All For Chinese X window Disguise Version 0.1

 This program is shameless stolen from XA+CV.
 I made some changes to make this program 
 from hackers writing to standard development method.
 
 It might be easier to read this program instead of XA+CV
 if you want to make some effort on Chinese X window.

 This version disabled CV functions.

 Author: Brian Lin, OK STATION Webmaster, foxman@okstation.com
 Source: http://linux.okstation.com/a4c.cx
 FTP   : ftp://ftp.okstation.com/all4chinese
\*********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <ctype.h>
#include <dlfcn.h>

#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xutil.h>
#include <X11/Shell.h> 
#include <X11/keysym.h>
#include <X11/Xlocale.h>

#define IS_ENDIAN()         (*(int *)"\x11\x22\x33\x44"==0x11223344)
#define XCIN_ATOM           "XCIN_A"
#define K_REJECT            0
#define K_ACCEPT            1
#define CLI_FOCUS_IN        1
#define CLI_FOCUS_OUT       3
#define LOAD_KEYWORD        2

#ifdef CV_SUPPORT
/***************************************************************\
                    Configuration Systems
\***************************************************************/
typedef struct {
  char * key;
  char * value;
} cfgItem;

typedef struct {
  int       Size;
  cfgItem * CFG;
} CfgSYS;

FILE * OpenSesame(void)
{
  char BUFF[512];
  char DIR[256];
  char * home = getenv("HOME");  
  if (home==NULL) home = getenv("home");
  if (home!=NULL) sprintf(DIR,"%s/.iome",home);
             else sprintf(DIR,"/etc/iome");
  sprintf(BUFF,"%s/disguise",DIR);
  if (access(BUFF,R_OK)!=0) {
    sprintf(DIR,"/etc/iome");
    sprintf(BUFF,"%s/disguise",DIR);
    if (access(BUFF,R_OK)!=0) return NULL;
  }
  return fopen(BUFF,"r");
}

int LoadConfiguration(CfgSYS *CFG)
{
  char buff[1024];
  char * p;
  char * key;
  char * value;
  FILE * fp = OpenSesame();
  if (fp==NULL) return 0;

  while (fgets(buff,1023,fp)) {
    p = buff;
    /* meet the first valid char */
    while (*p==' '||*p==9) p++;
    if (*p=='#') continue;  /* if it is comment, skip it */
    key = p; /* now, what we have, the first key */
    while (*p&&*p!=' '&&*p!=9) p++; /* find the separator */
    if (*p==0) continue; /* */
    *p = 0; p++;
    while (*p==' '||*p==9) p++;
    value = p;
    while (*p&&*p!=10&&*p!=13) p++;
    *p = 0;
    /* Append a new key */
    CFG->CFG = (cfgItem*)realloc(CFG->CFG,sizeof(cfgItem)*(CFG->Size));
    CFG->CFG[CFG->Size].key = strdup(key);
    CFG->CFG[CFG->Size].value = strdup(value);
    CFG->Size++;
  }
  fclose(fp);
  return CFG->Size;
}

char * WhichOne(CfgSYS *CFG,char *key)
{
  int n = 0;
  while (n<CFG->Size&&strcmp(CFG->CFG[n].key,key)!=0) n++;
  return (n==CFG->Size) ? NULL:CFG->CFG[n].value;
}

void FreeConfiguration(CfgSYS *CFG)
{
  while (CFG->Size>0) {
    CFG->Size--;
    free(CFG->CFG[CFG->Size].key);
    free(CFG->CFG[CFG->Size].value);
  }
}
#endif
/***************************************************************\

\***************************************************************/

extern int XNextEvent(Display * disp, XEvent * event);
extern int XLookupString(XKeyEvent * eve,char * buf,int len,KeySym * ksym,XComposeStatus * st);
extern int XDrawImageString(Display * disp,Drawable win,GC gc,int x,int y,_Xconst char * str,int length);
extern int XDrawString(Display * disp,Drawable win,GC gc,int x,int y,_Xconst char * str,int length);

/****************************************************************\
                       X window Toolkits
\****************************************************************/
#ifdef CV_SUPPORT
int xStringWidth(unsigned char *str,int len,int minc,int maxc,XCharStruct * perc)
{
  int n,c;
  int s = 0;
  
  for (n=0;n<len;n++,str++) {
    c = (int)*str;
    s += (c>=minc&&c<=maxc) ? perc[c-minc].width : 0;
  }
}

#define isCHINESE isBig5
#define isChineseChar(c) (((c)>=0xa1)&&((c)<=0xfe))
int isBig5(unsigned char ch[])
{
  return (isChineseChar(ch[0])&&
          (((0x40<=ch[1])&&(ch[1]<=0x7e))||
          ((0xa1<=ch[1])&&(ch[1]<=0xfe)))
         ) ? 2:0;
}

int isGB2312(unsigned char ch[])
{
  return (isChineseChar(ch[0])&&((0x80<=ch[1])&&(ch[1]<=0xfe))) ? 2:0;
}
#endif
/****************************************************************\
                       Load Chinese Fonts
\****************************************************************/
#ifdef CV_SUPPORT
#define CFNTMAX 20

int ChineseFonts = 0;
int FontIndex    = 0;
int FontWidth[CFNTMAX];
XFontStruct *FontFarm[CFNTMAX];
char *BaseFontName = NULL;

XFontStruct * InitFonts(Display * display, int width)
{
  char fname[200];
  int n;
  XFontStruct *CFC;

  /* Find Fonts in the FontFarm */
  for (n = 0; n < ChineseFonts; n++)
    if (FontWidth[n] == width) return FontFarm[n];

  /* Load a new font into farm */
  sprintf(fname, BaseFontName, width);
  CFC = XLoadQueryFont(display,fname);

  if (CFC==NULL) return NULL;

  printf("Loading %s\n",fname);  
  if (ChineseFonts<=CFNTMAX) ChineseFonts++;
  FontWidth[FontIndex] = width;
  FontFarm[FontIndex]  = CFC;
  FontIndex++; FontIndex%=CFNTMAX;
  
  return CFC;
}
#endif
/****************************************************************\
        Focus Functions - Shameless stolen from cli_xwin.c
\****************************************************************/
/* variables */

typedef struct {
  char kb_state;
  char _CurInMethod;
} InmdState;

typedef struct {
  int       len;
  int       status;
  InmdState inmdstate;
  char      tkey[512];
} XCIN_RES;

InmdState inmdstate;

Atom    XCIN     = 0;
Window  xwin     = None;
int     isEndian = 0;
XComposeStatus ComposeStatus={NULL,0};

int ConnectXCIN(Display *disp)
{
  if (xwin!=None) return 1;
  XCIN = XInternAtom(disp,XCIN_ATOM,False);
  xwin = XGetSelectionOwner(disp,XCIN);
  return (xwin==None) ? 0 : 1;
}

void SendFocus(Display *disp,Window win,int FOCUS)
{
  XClientMessageEvent event;
  char *t;

  if (!ConnectXCIN(disp)) return;

  event.type         = ClientMessage;
  event.window       = win;
  event.message_type = XCIN;
  event.format       = 8;

  t = event.data.b;
  t[0] = t[1] = t[2] = 0xff;
  t[3] = FOCUS;
  memcpy(&t[4],&inmdstate,sizeof(inmdstate));

  XSendEvent(disp,xwin,False,0,(XEvent *)&event);
}

void SwapEndian(char *v)
{
  char t;
  #define SW(n,w) t=*(n); *(n)=*(w); *(w)=t;
  SW(v,v+3); SW(v+1,v+2);
  #undef  SW
}

int ReadKeys(Display *disp,char *buff)
{
  Atom     ActualType;
  int      ActualFormat;
  int      i;
  u_long   nitems,morebytes;
  char *   ttt;
  char *   cp;
  XCIN_RES res;
  int      ofs = 0;

  do {
    if (XGetWindowProperty(
          disp,
          xwin,
          XCIN,
          ofs/4,
          (sizeof(XCIN_RES)+3)/4,
          True,
          AnyPropertyType,
          &ActualType,
          &ActualFormat,
          &nitems,
          &morebytes,
          (unsigned char **)&ttt
        )!=Success) { /* ERROR */ puts("error property!"); }
      memcpy((char*)(&res)+(ofs&~0x3),ttt,nitems);

      XFree(ttt);
      ofs = (ofs&~0x3) + nitems;
  } while ((!nitems && !ofs)||morebytes>0);

  if (isEndian) {
    SwapEndian((char*)&res.len);
    SwapEndian((char*)&res.status);
  }

  memcpy(buff,res.tkey,res.len);
  inmdstate = res.inmdstate;
  buff[res.len] = 0;
  return res.status;
}

int SendKey(Display *disp,Window win,XKeyEvent *eve,char *buf)
{
  XClientMessageEvent event;
  XEvent  err;
  char *  tmp = event.data.b;
  u_char  ttt[8];
  KeySym  keysym;
  int     count;

  if (!ConnectXCIN(disp)) return K_REJECT;

  event.type         = ClientMessage;
  event.window       = win;
  event.message_type = XCIN;
  event.format       = 32;

  count = XLookupString(eve,ttt,sizeof(tmp),(KeySym*)tmp,&ComposeStatus);
  memcpy(&tmp[4],&eve->state,4);
  XSendEvent(disp,xwin,False,0,(XEvent*)&event);
  XSync(disp,False);

  return ReadKeys(disp,buf);
}

/******************************************************************\
        This part load libX11.so and prepare for disguise
\******************************************************************/

#define X_NEXTEVENT         "XNextEvent"
#define X_DRAWSTRING        "XDrawString"
#define X_LOOKUPSTRING      "XLookupString"
#define X_DRAWIMAGESTRING   "XDrawImageString" 
#define X_DRAWIMAGESTRING16 "XDrawImageString16"

int (*xNextEvent)(Display * disp,XEvent *event);
int (*xDrawString)(
       Display *      disp,
       Drawable       win,
       GC             gc,
       int            x,
       int            y,
       _Xconst char * str,
       int            length
    );
int (*xLookupString)(
       XKeyEvent *      event,
       char *           buff_return,
       int              bytes_buffer,
       KeySym *         keysym_return,
       XComposeStatus * status
    );
int (*xDrawImageString)(
       Display *      disp,
       Drawable       win,
       GC             gc,
       int            x,
       int            y,
       _Xconst char * str,
       int            length
    );
int (*xDrawImageString16)(
       Display *         disp,
       Drawable          win,
       GC                gc,
       int               x,
       int               y,
       _Xconst XChar2b * str,
       int               length
    );

typedef int (*xDrawing)(
          Display *      disp,
          Drawable       win,
          GC             gc,
          int            x,
          int            y,
          _Xconst char * str,
          int            length
        );


#define IS_X11_LOADED() (libX11_HANDLE!=NULL)
#define NO_X11_LOADED() (libX11_HANDLE==NULL)

void * libX11_HANDLE = NULL;

static dont_wrap = 0;
static real_a = 1;
static not_real_a = 0;
static char bigbuf[500] = "\0";
static int kk;
static XKeyEvent eve2;
static int oldkcode;
static init = 0;
static Display *defdisplay;
static Window defw;
static xa_mode = 2, cv_mode = 0;

static char lib_path[200];

static int wrap_count = 0;
static void *handle;

static XGCValues xgcv, mygcv;

#define LIB_PATH "/usr/X11R6/lib/libX11.so.6"

#define A_SCAN_CODE 38

static saved = 0;
static XEvent sevent;

int LoadFunctions(char *libX11_so)
{
  if (IS_X11_LOADED()) return 0;
  libX11_HANDLE = dlopen(libX11_so,RTLD_LAZY);
  if (libX11_HANDLE==NULL) return 0;
  xNextEvent         = dlsym(libX11_HANDLE,X_NEXTEVENT);
  xLookupString      = dlsym(libX11_HANDLE,X_LOOKUPSTRING);
#ifdef CV_SUPPORT
  xDrawString        = dlsym(libX11_HANDLE,X_DRAWSTRING);
  xDrawImageString   = dlsym(libX11_HANDLE,X_DRAWIMAGESTRING);
  xDrawImageString16 = dlsym(libX11_HANDLE,X_DRAWIMAGESTRING16);
#endif
  return 0;
}

void InitDisguise(Display *disp)
{
#ifdef CV_SUPPORT
  CfgSYS SYS;
  char * font;
#endif
  int n;
  
  LoadFunctions("libX11.so");
  isEndian = IS_ENDIAN();

#ifdef CV_SUPPORT
  memset(&SYS,0,sizeof(SYS));
  if (!LoadConfiguration(&SYS)) 
    printf("OH! No good, can not read configuration file\n");
  
  font = WhichOne(&SYS,"disguise.font");
  if (font) BaseFontName = strdup(font);

  FreeConfiguration(&SYS);

  /* Preload fonts */
//  for (n=3;n<12;n++) InitFonts(disp,n*20);
  printf("Initialize All For Chinese CX Disguise\n");
#endif
}

int xWrapIt(int type)
{
  switch (type) {
    case 0: return (dont_wrap||cv_mode==1);
    case 1: return (dont_wrap||!xa_mode);
    case 2: return dont_wrap;
  }
  return 1;
}

static int do_key(Display * display, XKeyEvent * xke, void *handle)
{
	char ybuf[2000];

	if (xke->keycode == A_SCAN_CODE && not_real_a > 0) {
		not_real_a--;
		return 0;
	}
	defdisplay = display;
	memcpy(&defw, &(xke->window), sizeof defw);
	dont_wrap = 1;
	kk = SendKey(display, defw, xke, ybuf);
	dont_wrap = 0;

	init = 1;
	if (!kk) {
		if (xke->keycode == A_SCAN_CODE)
			real_a = 1;
		return 1;
	}
	if (ybuf[0]) {
		xke->state = 0;
		xke->keycode = A_SCAN_CODE;
		real_a = 0;
		strcpy(bigbuf, ybuf);
		return 1;
	}
	return 0;
}

/**********************************************************\
  Select Mode Window - Shameless stolen from select_mode.c
\**********************************************************/
static char *mode_str[4] = {"Disable", "Traditional", "Discrete","CopyPaste"};
static char *cvmode_str[3] = {"Fix", "Off","SIZE"};
static XWMHints wmhints;
static GC gc;
static XClassHint class;
static XSizeHints sizehint;
static Window mywin;

#define MW_EVENTS (	KeyPressMask		|\
			FocusChangeMask		|\
			StructureNotifyMask	|\
			ButtonPressMask		|\
			ExposureMask		|\
			PropertyChangeMask	|\
			VisibilityChangeMask	\
		)

void DisguiseSelectMode(Display * disp, int *mode, int *cvmode)
{
  char *uu = "All For Chinese CX Disguise";
  unsigned long fg, bg;
  int hide = 0;
  int count = 0;
  char buf[200];
  XTextProperty name;
  KeySym keysym;
  static XComposeStatus compose = {NULL, 0};

  /* Open Window */
  sizehint.flags = (PPosition | PSize);
  sizehint.height = 400;
  sizehint.width = 40;
  sizehint.x = DisplayWidth(disp, DefaultScreen(disp)) / 2;
  sizehint.y = DisplayHeight(disp, DefaultScreen(disp)) / 2;

  wmhints.initial_state = NormalState;
  wmhints.flags = InputHint | StateHint;
  class.res_class = "CX Disguise";
  class.res_name  = "CX Disguise";

  fg = WhitePixel(disp, DefaultScreen(disp));
  bg = BlackPixel(disp, DefaultScreen(disp));

  mywin = XCreateSimpleWindow(
            disp, 
            DefaultRootWindow(disp),
            sizehint.x, 
            sizehint.y, 
            sizehint.height, 
            sizehint.width,
            1, fg, bg
          );

  gc = XCreateGC(disp, mywin, 0, NULL);
  if (XStringListToTextProperty(&uu, 1, &name) == 0) {
    /* Error - Can not allocate window */
    return;
  }
  XSetWMProperties(
    disp, 
    mywin,
    &name, 
    &name,
    NULL, 
    0, 
    &sizehint, 
    &wmhints, 
    &class
  );
  XSelectInput(disp, mywin, MW_EVENTS);
  XMapWindow(disp, mywin);
  XMoveWindow(disp, mywin, sizehint.x, sizehint.y);
  while (1) {
    XEvent event;
    XKeyEvent *xke = (XKeyEvent *) (&event);
    count = 0;

    XNextEvent(disp, &event);
    
    switch (event.type) {
      case KeyPress:
        count = XLookupString(xke, buf, 10, &keysym, &compose);
        count = 1;
      break;
    }
  
    if (count > 0) {
      if (buf[0] >= '0' && buf[0] <= '3') *mode = buf[0] - '0'; else 
      if (buf[0] >= 'a' && buf[0] <= 'c') *cvmode = buf[0] - 'a';
      break;
    }

    /* Draw Window */
    XSetForeground(disp, gc, fg);
    XSetBackground(disp, gc, bg);

    sprintf(
      buf, 
      "XA Mode:%d)%s [0-3];+CV Mode:%c)%s [a-c]"
      ,*mode, 
      mode_str[*mode]
      ,(*cvmode) + 'a', 
      cvmode_str[*cvmode]
    );
    XDrawString(disp, mywin, gc, 10, 30, buf, strlen(buf));
  }

  /* Destroy Setting Window */
  XDestroyWindow(disp, mywin);
  XFreeGC(disp, gc);
}

/*****************************************************************\
                         Disguise functions
\*****************************************************************/
#ifdef CV_SUPPORT
int xDisguise(
       Display *      disp,
       Drawable       win,
       GC             gc,
       int            x,
       int            y,
       _Xconst char * str,
       int            length,
       xDrawing       DRAW
    )
{
  int EW,CW;
  int EMIN,EMAX;
//  int CMIN,CMAX;
  XFontStruct * EFONT;
  XFontStruct * CFONT;
  Atom atm;
  int n = 0, lastone = 0, w;
  int chinese = 0;
  long prop[20];
  char * p;

  XGetGCValues(disp,gc,GCFont,&xgcv);
  EFONT = XQueryFont(disp,xgcv.font);
  EW    = EFONT->max_bounds.width;
  EMIN  = EFONT->min_char_or_byte2;
  EMAX  = EFONT->max_char_or_byte2;
  CW    = EW;

  while (n<length) {
    /* Find First Chinese String */
    w = 0; p = (char*)str;
    while (n<length&&!isCHINESE((unsigned char*)str)) {
      str++; w++; n++;
    }
    if (w>0) {
      xgcv.font = EFONT->fid;
      XChangeGC(disp, gc, GCFont, &xgcv);
      DRAW(disp,win,gc,x,y,p,w);
      x += xStringWidth(p,w,EMIN,EMAX,EFONT->per_char);
    }
    if (n==length) break;
    if (chinese==0) {
      int wx;
      atm = XInternAtom(disp, "AVERAGE_WIDTH", False);
      if (CW<0 && XGetFontProperty(EFONT,atm,prop)) CW = prop[0] * 2;
      if (CW<0) CW = -CW;
      wx = CW*12; wx -= wx%10;
      CFONT = InitFonts(disp,wx);
      if (CFONT==NULL) {
        XFreeFontInfo(NULL,EFONT,1);
        return DRAW(disp,win,gc,x,y,str,length-n);
      }
    }
    w = 0; p = (char*)str;
    while (n<length&&isCHINESE((unsigned char *)str)) {
      str++; str++; w++; n++; n++;
    }
    if (w>0) {
      xgcv.font = CFONT->fid;
      XChangeGC(disp, gc, GCFont, &xgcv);
      xDrawImageString16(disp,win,gc,x,y,(XChar2b*)p,w);
      x += w*CW;
    }
  }
  xgcv.font = EFONT->fid;
  XChangeGC(disp,gc,GCFont,&xgcv);
  XFreeFontInfo(NULL, EFONT, 1);
  return 1;
}

int XDrawString(
       Display *      disp,
       Drawable       win,
       GC             gc,
       int            x,
       int            y,
       _Xconst char * str,
       int            length
    )
{
  if NO_X11_LOADED() InitDisguise(disp);
  if (xWrapIt(0)) return xDrawString(disp,win,gc,x,y,str,length);
  return xDisguise(disp,win,gc,x,y,str,length,xDrawString);
}

int XDrawImageString(
       Display *      disp,
       Drawable       win,
       GC             gc,
       int            x,
       int            y,
       _Xconst char * str,
       int            length
    )
{
  if NO_X11_LOADED() InitDisguise(disp);
  if (xWrapIt(0)) return xDrawImageString(disp,win,gc,x,y,str,length);
  return xDisguise(disp,win,gc,x,y,str,length,xDrawImageString);
}
#endif
int XLookupString(
       XKeyEvent *      eve,
       char *           buf,
       int              len,
       KeySym *         ksym,
       XComposeStatus * st
    )
{
  if NO_X11_LOADED() InitDisguise(NULL);
  if (xWrapIt(1)) return xLookupString(eve,buf,len,ksym,st);

  if (init && !real_a && eve->keycode == A_SCAN_CODE && strlen(bigbuf)) {
    eve->keycode = A_SCAN_CODE;
    xLookupString(eve, buf, len, ksym, st);
    if (xa_mode == 1) {
      strncpy(buf, bigbuf, len - 1);
      buf[len - 1] = 0;
      return strlen(buf);
    } else {
      buf[0]=bigbuf[0];
      return 1;
    }
  } else
    return xLookupString(eve,buf,len,ksym,st);
}

int XNextEvent(Display * disp, XEvent * event)
{
  int rtn;

  if NO_X11_LOADED() InitDisguise(disp);

  if (xa_mode == 2 && saved && strlen(bigbuf) > 1) {
    int i, j;
    XKeyEvent *xke = (XKeyEvent *) event;

    j = strlen(bigbuf);
    if (j == 2) {
      XKeyEvent *xke = (XKeyEvent *) event;

       XPeekEvent(disp, event);
       if (event->type == KeyPress && not_real_a > 0)
         if (xke->keycode == A_SCAN_CODE) {
           rtn = xNextEvent(disp, event);
           not_real_a--;
         }
       }
       for (i = 0; i < j; i++) bigbuf[i] = bigbuf[i + 1];
       memcpy(event, &sevent, sizeof(sevent));
       xke->state = 0;
       xke->keycode = A_SCAN_CODE;
       real_a = 0;
       return 0;
    }

ne_start:

  rtn = xNextEvent(disp, event);
  
  if (event->type == KeyPress) {
    XKeyEvent *xke = (XKeyEvent *) event;
    KeySym ks;
    char smallbuf[20];

    memcpy(&sevent, event, sizeof(sevent));
    saved = 1;

    dont_wrap = 1;

    if (!XLookupString(xke, smallbuf, sizeof(smallbuf), &ks, NULL)
        && !strcmp(XKeysymToString(ks), "F12")) {
      DisguiseSelectMode(xke->display, &xa_mode, &cv_mode);
      if (xa_mode == 2) bigbuf[0] = 0;
      dont_wrap = 0;
      goto ne_start;
    }

    dont_wrap = 0;
    if (!xa_mode) return 0;

    if (!do_key(disp, xke, handle)) goto ne_start;
    
    if (!real_a && bigbuf[0] && xke->keycode == A_SCAN_CODE) {
      if (xa_mode!=3) {
        XPutBackEvent(disp, event);
        not_real_a++;
      } else {
        XSelectionEvent * notify = (XSelectionEvent *)event;
        XButtonEvent    * xbe    = (XButtonEvent *)event;

        XSetSelectionOwner(disp, XA_PRIMARY, defw, xke->time);

        if (XGetSelectionOwner(disp, XA_PRIMARY) != defw) {
          /* ERROR */
        }

        XChangeProperty(
          disp, 
          DefaultRootWindow(disp),
          XA_CUT_BUFFER0,
          XA_STRING, 
          8, 
          PropModeReplace, 
          bigbuf, 
          strlen(bigbuf)
        );

        event->type=ButtonPress;
        xbe->button=Button2;
        XPutBackEvent(disp, event);  
        event->type=ButtonRelease;
        xbe->button=Button2;
      }
    }
  } else 
  if (event->type == FocusIn) {
    if (init) {
      SendFocus(defdisplay,defw,CLI_FOCUS_IN);
    } else 
    if (event->type==SelectionRequest) {
      /* SelectionRequest */
    }
  }
  return rtn;
}

